package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.rulematch;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesNumberRuleMatchDispatchService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProductionAssembly;
import cn.estsh.i3plus.pojo.mes.repository.MesProductionAssemblyRepository;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 外协件规则匹配且唯一
 */
@Slf4j
@Service
public class MesNumberRuleMatchAndUniqueService implements IMesNumberRuleMatchDispatchService {

    @Autowired
    private MesProductionAssemblyRepository productionAssemblyRepository;

    @Override
    public Boolean matchNumberRule(String organizeCode, String sn, Object... params) {
        // 校验正则表达式
        Boolean result = ((IMesNumberRuleMatchDispatchService) SpringContextsUtil.getBean(MesExtEnumUtil.ASSEMBLY_MATCH_TYPE.MATCH_TYPE_20.getStrategyClass())).matchNumberRule(organizeCode, sn, params);

        if (!result) return false;

        // 校验是否唯一
        return validateUnique(organizeCode, sn);

    }

    /**
     * 验证唯一
     * @param organizeCode
     * @param sn
     * @return
     */
    private boolean validateUnique(String organizeCode, String sn) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(sn, MesPcnExtConstWords.ASSEMBLY_SN, ddlPackBean);
        MesProductionAssembly productionAssembly = productionAssemblyRepository.getByProperty(ddlPackBean);
        if (productionAssembly != null) {
            return false;
        }
        return true;
    }
}
